package org.n52.ifgicopter.spf;

import java.util.Map;

import org.n52.ifgicopter.spf.common.IModule;
import org.n52.ifgicopter.spf.gui.PluginGUI;
import org.n52.ifgicopter.spf.output.IOutputPlugin;
import org.n52.ifgicopter.spf.xml.Plugin;

/**
 * Template for an IOuputPlugin implementation.
 * 
 * @author matthes rieke <m.rieke@52north.org>
 *
 */
public class TemplateOutputPlugin implements IOutputPlugin {

	@Override
	public void init() throws Exception {
		/*
		 * here you could initialized resource
		 * you need for your plugin to work.
		 * 
		 * e.g. check if a web service is available
		 */
	}

	@Override
	public void shutdown() throws Exception {
		/*
		 * here you should free all used
		 * resources again
		 */
	}

	@Override
	public String getName() {
		/*
		 * return a human readable name for the plugin
		 */
		return "TemplateOutputPlugin";
	}

	@Override
	public int getStatus() {
		/*
		 * inform the framework about our state
		 */
		return IModule.STATUS_RUNNING;
	}

	@Override
	public String getStatusString() {
		/*
		 * Human readable version of the status
		 */
		return "Everything as expected.";
	}

	@Override
	public PluginGUI getUserInterface() {
		/*
		 * if you want your plugin to provide a user interface,
		 * return an instance of PluginGUI here. Else, return null.
		 */
		return null;
	}

	@Override
	public int processData(Map<Long, Map<String, Object>> data, Plugin inputPlugin) {
		/*
		 * The actual processing of data.
		 * This is the "Map-of-Maps" version.
		 * For convenience, we simply call processSingleData.
		 */
		for (Long ts : data.keySet()) {
			processSingleData(data.get(ts), ts, inputPlugin);
		}
		
		return IModule.STATUS_RUNNING;
	}

	@Override
	public int processSingleData(Map<String, Object> data, Long timestamp,
			Plugin inputPlugin) {
		/*
		 * The actual processing of data.
		 */
		
		System.out.println("["+timestamp +" | "+inputPlugin +"] "+ data);
		
		return IModule.STATUS_RUNNING;
	}

	@Override
	public void restart() throws Exception {
		/*
		 * restart the plugin. could be handsome, if plugins have changed
		 * their phenomena at runtime.
		 */
	}

}
